//+------------------------------------------------------------------+
//|                                                          Ind.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, "
#property link      "Jane"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
//----
input bool       UseCenterLineFilter=false;
input bool       UseRVIFilter=false;
input bool       UseAlert =true;
input bool        UseMail =true;
input bool       UsePopup = true;
input color  ArrowColorUp =clrBlue;
input color  ArrowColorDn =clrRed;
input string    FileSound ="alert.wav";
//----
int      account =3123632;
extern int       period =20;
extern double deviation =2.0;
extern double      step =0.02;
extern double   maximum =0.2;
extern int       indent =0;
//----
double ExtArrowBufferUp[];
double ExtArrowBufferDn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorShortName("Ind");
   IndicatorDigits(_Digits);
//----
   SetIndexBuffer(0,ExtArrowBufferUp);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1,ArrowColorDn);
   SetIndexArrow(0,234);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Up");
   SetIndexBuffer(1,ExtArrowBufferDn);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1,ArrowColorUp);
   SetIndexArrow(1,233);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Dn");
//----
   HideTestIndicators(true);
//----
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //if(account>0)
   //   if(account!=AccountInfoInteger(ACCOUNT_LOGIN))
   //      return(0);
//----
   int limit=0;
//----
   if(prev_calculated==0)
      limit=rates_total-1;
//----
   if(prev_calculated>0)
      limit=rates_total-prev_calculated;
//----
   for(int i=limit;i>=0;i--)
     {
      double bb_up=iBands(_Symbol,_Period,period,deviation,0,PRICE_CLOSE,MODE_UPPER,i);
      double bb_lw=iBands(_Symbol,_Period,period,deviation,0,PRICE_CLOSE,MODE_LOWER,i);
      double sar_curr=iSAR(_Symbol,_Period,step,maximum,i);
      double sar_prev=iSAR(_Symbol,_Period,step,maximum,i+1);
      double ma_center_curr=iMA(_Symbol,_Period,period,0,MODE_SMA,PRICE_CLOSE,i);
      double ma_center_prev=iMA(_Symbol,_Period,period,0,MODE_SMA,PRICE_CLOSE,i+1);
      double rvi_main=iRVI(_Symbol,_Period,period*5,MODE_MAIN,i);
      double rvi_signal=iRVI(_Symbol,_Period,period*5,MODE_SIGNAL,i);
      
      
      //----
      if(sar_prev<bb_up)
         if(sar_curr>bb_up)
          if ((UseCenterLineFilter && ma_center_prev>ma_center_curr) || !UseCenterLineFilter)
          if ((UseRVIFilter && rvi_main<rvi_signal) || !UseRVIFilter)
           {
            ExtArrowBufferUp[i]=sar_curr+indent*_Point;
            //----
               if(i==1)
                 {
                  if(UseAlert==true)
                     PlaySound(FileSound);
                  //----
                  if(UseMail==true)
                     SendMail("mail indicator",_Symbol+","+PeriodToString()+"  SELL");
                     
                  if (UsePopup) Alert(_Symbol+","+PeriodToString()+"  SELL");
                 }
           }
      //----
      if(sar_prev>bb_lw)
         if(sar_curr<bb_lw)
          if ((UseCenterLineFilter && ma_center_prev<ma_center_curr) || !UseCenterLineFilter)
          if ((UseRVIFilter && rvi_main>rvi_signal) || !UseRVIFilter)
           {
            ExtArrowBufferDn[i]=sar_curr-indent*_Point;
            //----
               if(i==1)
                 {
                  if(UseAlert==true)
                     PlaySound(FileSound);
                  //----
                  if(UseMail==true)
                     SendMail("mail indicator",_Symbol+","+PeriodToString()+"  BUY");
                  if (UsePopup) Alert(_Symbol+","+PeriodToString()+"  BUY");
                 }
           }
     }
//----
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string PeriodToString()
  {
   switch(_Period)
     {
      case PERIOD_M1:  return("M1");
      case PERIOD_M5:  return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1:  return("H1");
      case PERIOD_H4:  return("H4");
      case PERIOD_D1:  return("D1");
      case PERIOD_W1:  return("W1");
      case PERIOD_MN1: return("MN1");
      //----
      default: return("");
     }
//----
   return("");
  }
//+------------------------------------------------------------------+
